float vehicleWidth=100;
float vehicleDepth=80;
float wheelRadius = 60;
float wheelWidth = 20;
float sensorDist=50;
float sensorHeadRadius=10;

int img_x=800;
int img_y=800;

int LeftSensor=0;
int RightSensor=0;

PrintWriter writer;
BufferedReader reader;

float init_sx, init_sy, init_sq=0;

PImage img;
color Pixel;
boolean flag_start=false;
int draw_step=1;

float sx, sy, sq;

float vel_R=0;
float vel_L=0;

int gCount;
int cCount;

float time=0;
float count=0;
int fps = 10;

void setup() {
  size(800, 800); 
  rectMode(CENTER);
  background(100);

  frameRate(fps);

  img = loadImage("course2.bmp");
  img.loadPixels(); 

  reader = createReader("init_pos.txt");
  String line;
  try {
    line = reader.readLine();
  }
  catch(IOException e) {
    line = null;
  }
  float p1[] = float(split(line,'\t'));
  init_sx = p1[0];
  init_sy = p1[1];
  init_sq = p1[2];
  try {
    reader.close();
  }
  catch(IOException e) {
  }
  writer = createWriter("data.txt");

  reader = createReader("dataline.txt");
  try {
    line = reader.readLine();
  }
  catch(IOException e) {
    line = null;
  }
  float p2[] = float(split(line,'\t'));
  gCount = int(p2[0]);
//  score = p2[1];
  action_vel_L[0] = p2[2];
  action_vel_R[0] = p2[3];
  action_vel_L[1] = p2[4];
  action_vel_R[1] = p2[5];
  action_vel_L[2] = p2[6];
  action_vel_R[2] = p2[7];
  action_vel_L[3] = p2[8];
  action_vel_R[3] = p2[9];
  try {
    reader.close();
  }
  catch(IOException e) {
  }

  
}

void draw() {
   if (flag_start==false) {
    image(img, 0, 0, img_x, img_y); 
    img.loadPixels();
   }

  fill(0);
  textSize(16);    
  text(time/fps, 10, 20);
  text("x"+draw_step, 100, 20);
  text("g:"+gCount, 10, 40);
  text("c:"+cCount, 10, 60);

  if (flag_start) {
    robot(sx, sy, sq);
    Move();
  }
}

void mouseWheel(MouseEvent event) {
  float e = event.getCount();
  init_sq +=radians(e*10);
}

void mousePressed() {
  if (mouseButton==LEFT) {
    if (flag_start==false) {

      flag_start=true;
      sx = init_sx;
      sy = init_sy;  
      sq = init_sq;

    }
  } else if (mouseButton==RIGHT) {
    if (draw_step==1000) {
      draw_step=1;
    } else {
      draw_step*=10;
    }
  }
}

void exit() {
  writer.flush();
  writer.close();

  super.exit();
}

void robot(float X, float Y, float Qdeg) {

  GetSensor(X, Y, Qdeg);

  translate(X, Y);

  pushMatrix();
  rotate(Qdeg);

  stroke(0, 0, 0, 255);
  fill(0, 0, 0, 255);
  ellipse(0, 0, 5, 5);  

  fill(0, 0, 0, 255);   
  line(-vehicleWidth/2-wheelWidth/2, 0, vehicleWidth/2+wheelWidth/2, 0);   

  fill(200, 200, 200, 255);   
  rect(-vehicleWidth/2, 0, wheelWidth, wheelRadius, 7);
  rect( vehicleWidth/2, 0, wheelWidth, wheelRadius, 7);

  fill(255, 255, 255, 100);
  rect(0, -wheelRadius/2, vehicleWidth*0.8, vehicleDepth+wheelRadius); 

  int sx_Left = (int)(-sensorDist/2);
  int sy_Left = (int)(-vehicleDepth);
  if (LeftSensor == 1) {
    stroke(255, 255, 255, 255);
    fill(63, 63, 63, 255);
  } else {
    stroke(0, 0, 0, 255);
    fill(255, 255, 255, 100);
  }
  ellipse(sx_Left, sy_Left, sensorHeadRadius*2, sensorHeadRadius*2);   

  int sx_Right = (int)(sensorDist/2);
  int sy_Right = sy_Left;
  if (RightSensor == 1) {
    stroke(255, 255, 255, 255);
    fill(63, 63, 63, 255);
  } else {
    stroke(0, 0, 0, 255);
    fill(255, 255, 255, 100);
  }
  ellipse(sx_Right, sy_Right, sensorHeadRadius*2, sensorHeadRadius*2);   

  noFill();
  popMatrix();
}

void GetSensor(float X, float Y, float Angle) {
  float l= vehicleDepth;
  float d= sensorDist/2;
  float cosQ=cos(Angle);
  float sinQ=sin(Angle);
  int Sx_Left, Sy_Left;
  int Sx_Right, Sy_Right;

  int x_Left = (int)(l*sinQ - d*cosQ + X);
  int y_Left = (int)(-l*cosQ - d*sinQ + Y);

  int x_Right = (int)(l*sinQ + d*cosQ + X);
  int y_Right = (int)(-l*cosQ + d*sinQ + Y);

  Sx_Left = x_Left;
  Sy_Left = y_Left;
  if (Sx_Left < 0) {
    Sx_Left += img_x;
  }
  if (Sx_Left > img_x) {
    Sx_Left -=img_x;
  } 
  if (Sy_Left < 0) {
    Sy_Left += img_y;
  }
  if (Sy_Left > img_y) {
    Sy_Left -= img_y;
  }
  int num = (Sy_Left*width)+Sx_Left;
  if (num >= 0 && num < width*height) {
    Pixel = img.pixels[num];
    if (int(brightness(Pixel))==0) {
      LeftSensor = 1;
    } else {
      LeftSensor = 0;
    }
  } else {
    LeftSensor = 0;
  }

  Sx_Right = x_Right;
  Sy_Right = y_Right;
  if (Sx_Right < 0) {
    Sx_Right += img_x;
  }
  if (Sx_Right > img_x) {
    Sx_Right -=img_x;
  } 
  if (Sy_Right < 0) {
    Sy_Right += img_y;
  }
  if (Sy_Right > img_y) {
    Sy_Right -= img_y;
  }
  num = (Sy_Right*width)+Sx_Right;
  if (num >= 0 && num < width*height) {
    Pixel = img.pixels[num];
    if (int(brightness(Pixel))==0) {
      RightSensor = 1;
    } else {
      RightSensor = 0;
    }
  } else {
    RightSensor = 0;
  }
}

void UpdateState() {
  float t_sq=(vel_L-vel_R)/vehicleWidth;
  float t_vel=(vel_L+vel_R)/2;

  sq += t_sq;
  sx += t_vel*sin(sq);
  sy -= t_vel*cos(sq);

  if (sx < 0) {
    sx += img_x;
  }
  if (sx >= img_x) {
    sx -=img_x;
  } 
  if (sy < 0) {
    sy += img_y;
  }
  if (sy >= img_y) {
    sy -= img_y;
  }
}

int GetState() {
  int state=0;
  if (LeftSensor== 1 && RightSensor==1) {
    state = 0;
  } else if (LeftSensor==1 && RightSensor==0) {
    state = 1;
  } else if (LeftSensor==0 && RightSensor==1) {
    state = 2;
  } else if (LeftSensor==0 && RightSensor==0) { 
    state = 3;
  }
  return state;
} 