final int SIM_COUNT=1000;
final int STATE_NUM=4;

float score = 0;
float [] action_vel_L = new float [STATE_NUM];
float [] action_vel_R = new float [STATE_NUM];
float old_score = 0;
float [] old_action_vel_L = new float [STATE_NUM];
float [] old_action_vel_R = new float [STATE_NUM];

void Init()
{
  score = 0;
  for (int i=0; i<STATE_NUM; i++) {
    action_vel_L[i]=random(2);
    action_vel_R[i]=random(2);
  }
  old_score = score;
  for (int i=0; i<STATE_NUM; i++) {
    old_action_vel_L[i]=action_vel_L[i];
    old_action_vel_R[i]=action_vel_R[i];
  }
}

void Move()
{
  if(count==-1)return;
  for (int step=0; step<draw_step; step++) {
    GetSensor(sx, sy, sq);
    SetAction();
    UpdateState();
    count++;
    time=count/fps;
    if (count>=SIM_COUNT) {
      count = -1;
//      gCount++;
      Yamanobori();
      break;
    }
  }
}

int SetAction() {

  int state  = GetState();

  vel_L=action_vel_L[state];
  vel_R=action_vel_R[state];
  
  if (state == 1 || state == 2) {
    score+=abs((vel_L+vel_R)/2);
  }
  else{
    score+=abs((vel_L+vel_R)/2*0.2);
  }

  return 0;
}

void Yamanobori()
{
  writer.print(gCount+"\t"+score);
  for (int i=0; i<STATE_NUM; i++) {
    writer.print("\t"+action_vel_L[i]);
    writer.print("\t"+action_vel_R[i]);
  }
  writer.println();
  writer.flush();

  if (old_score>score) {
    score = old_score;
    for (int i=0; i<STATE_NUM; i++) {
      action_vel_L[i]=old_action_vel_L[i];
      action_vel_R[i]=old_action_vel_R[i];
    }
  }
  else{
    old_score = score;
    for (int i=0; i<STATE_NUM; i++) {
      old_action_vel_L[i]=action_vel_L[i];
      old_action_vel_R[i]=action_vel_R[i];
    }
  }
  score=0;
  float rs;
  if (random(1)<0.9)rs=10;
  else rs=1;
  for (int i=0; i<STATE_NUM; i++) {
    action_vel_L[i]+=(random(2)-1)/rs;
    action_vel_R[i]+=(random(2)-1)/rs;
    if(action_vel_L[i]<-5)action_vel_L[i]=-5;
    if(action_vel_L[i]>5)action_vel_L[i]=5;
    if(action_vel_R[i]<-5)action_vel_R[i]=-5;
    if(action_vel_R[i]>5)action_vel_R[i]=5;
  }
}